#3914 Unable to connect via IPv6

1.550
closed-fixed
nobody
None
5
2011-05-13
2011-05-11
Anonymous
No

I run webmin on a dual-stack 4/6 server and have native 4 on my client machine and 6 provided via a 6to4 tunnel with a globally routed 6 address. Connecting to my server via hostname (which has both A and AAAA records) gives me a connection reset error in both IE and Chrome. Connecting by IPv4 address directly or disabling my v6 on the client machine works properly. My webmin is configured to run via xinetd.

This is the error generated in my miniserv.error log:
Bad arg length for Socket::unpack_sockaddr_in, length is 28, should be 16 at /usr/share/webmin/miniserv.pl line 3667.

And a TCP dump of me trying to connect via IPv6:

07:42:35.436161 IP6 (hlim 56, next-header TCP (6) payload length: 32) 2001:470:my:pc.60121 > my.server.webmin: Flags [S], cksum 0x1de2 (correct), seq 1970971692, win 8192, options [mss 1440,nop,wscale 8,nop,nop,sackOK], length 0
07:42:35.436191 IP6 (hlim 64, next-header TCP (6) payload length: 32) my.server.webmin > 2001:470:my:pc.60121: Flags [S.], cksum 0x1f49 (correct), seq 3023918029, ack 1970971693, win 5760, options [mss 1440,nop,nop,sackOK,nop,wscale 5], length 0
07:42:35.517983 IP6 (hlim 56, next-header TCP (6) payload length: 20) 2001:470:my:pc.60121 > my.server.webmin: Flags [.], cksum 0x7583 (correct), ack 1, win 258, length 0
07:42:35.518015 IP6 (hlim 56, next-header TCP (6) payload length: 209) 2001:470:my:pc.60121 > my.server.webmin: Flags [P.], cksum 0xe460 (correct), seq 1:190, ack 1, win 258, length 189
07:42:35.518025 IP6 (hlim 64, next-header TCP (6) payload length: 20) my.server.webmin > 2001:470:my:pc.60121: Flags [.], cksum 0x74f2 (correct), ack 190, win 214, length 0
07:42:37.617824 IP6 (hlim 64, next-header TCP (6) payload length: 20) my.server.webmin > 2001:470:my:pc.60121: Flags [R.], cksum 0x74ee (correct), seq 1, ack 190, win 214, length 0

Discussion

  • Jamie Cameron

    Jamie Cameron - 2011-05-11
    • status: open --> closed-fixed
     
  • Comment has been marked as spam. 
    Undo

    You can see all pending comments posted by this user  here

    Anonymous - 2011-05-12

    Thanks for such a quick fix! It was me who reported this; applied the fix to my usermin install too and both work great across v6 now :)

     
  • Comment has been marked as spam. 
    Undo

    You can see all pending comments posted by this user  here

    Anonymous - 2011-05-13

    Is it possible to re-open this? Or should I make a new item? Things worked well immediately after I patched, but is now giving me the same problem again since I have tried to connect to my webmin the next day.

     
  • Jamie Cameron

    Jamie Cameron - 2011-05-13

    Ok, re-opening ..

    Are you still getting the same error?

     
  • Jamie Cameron

    Jamie Cameron - 2011-05-13
    • status: closed-fixed --> open-accepted
     
  • Comment has been marked as spam. 
    Undo

    You can see all pending comments posted by this user  here

    Anonymous - 2011-05-13

    Yes, identical error. Let me know if you need server specs, tcp dumps, etc. Not sure what will prove useful to you.

     
  • Jamie Cameron

    Jamie Cameron - 2011-05-13
    • status: open-accepted --> closed-fixed
     
  • Nobody/Anonymous

    Still receiving that error, albeit reported at line 3669.

     
  • Comment has been marked as spam. 
    Undo

    You can see all pending comments posted by this user  here

    Anonymous - 2011-05-13

    Added; no change. Connecting via IPv6 on both ends verified with tcpdump.

    10:21:08.778485 IP6 2001:470:snip::5.61383 > 2001:470:snip:498c.10000: Flags [S], seq 1447869355, win 8192, options [mss 1440,nop,wscale 8,nop,nop,sackOK], length 0

     
  • Jamie Cameron

    Jamie Cameron - 2011-05-13

    Could you try running :

    strace -o /tmp/strace.out -f -p XXX

    where XXX is the xinetd PID, then try connecting with your browser. Then kill strace and attach /tmp/strace.out to this bug report (or email it to me at jcameron@webmin.com )

     

Log in to post a comment.